//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include<stdio.h>
#include<alloc.h>
#include "EnumServer.h"
#include "eval.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TEnumServerForm *EnumServerForm;
//---------------------------------------------------------------------------
__fastcall TEnumServerForm::TEnumServerForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TEnumServerForm::CancelBtnClick(TObject *Sender)
{
   DevIDEdit->SetTextBuf("FFFF");
   NumServersEdit->SetTextBuf("10");
   ComboBoxServerInfo->Clear();
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TEnumServerForm::ExecuteBtnClick(TObject *Sender)
{
   SP_STATUS status; //fullStatus;
   char szTemp[50];
   char szdev[6];
   RB_WORD   DevID;
   char sznumserv[5];   
   RB_WORD   NumSrvrs = 0;
   int       EnumFlag, i;
   NSPRO_SERVER_INFO *srvrInfo;
   NSPRO_SERVER_INFO *countersrvrinfo;
   char szenumflag[30];
   char      msgSrvrInfo[100];//this will store the srvrInfo.
   TMainForm* mainFrm;
   int    tempOutput;

   DevIDEdit->GetTextBuf(szdev, 6);
   NumServersEdit->GetTextBuf(sznumserv,5);
   ComboBoxEnumFlag->GetTextBuf(szenumflag,30);

   if(!strcmp(szenumflag,""))
   {
      MessageBox(NULL, "Select an enum flag to proceed.", "EnumServer", MB_OK | MB_TASKMODAL );
      return;
   }
   if(!strcmp(szenumflag,"NSPRO_GET_ALL_SERVERS"))
      EnumFlag = NSPRO_GET_ALL_SERVERS;
   else if(!strcmp(szenumflag,"NSPRO_RET_ON_FIRST_AVAILABLE"))
      EnumFlag = NSPRO_RET_ON_FIRST_AVAILABLE;
   else if(!strcmp(szenumflag,"NSPRO_RET_ON_FIRST"))
      EnumFlag = NSPRO_RET_ON_FIRST;
   else
   {
      MessageBox(NULL, "Select an enum flag to proceed.", "EnumServer", MB_OK | MB_TASKMODAL );
      return;
   }

   if(!strcmp(szdev,""))
   {
      MessageBox(NULL, "Specify Developer ID to proceed.", "EnumServer", MB_OK | MB_TASKMODAL );
      return;
   }
   if (mainFrm->ValidateInput(szdev,&DevID,"EnumServer","Developer ID",MAX_CELL_DATA_LEN))
      return;

   if(!strcmp(sznumserv,""))
   {
     MessageBox(NULL, "Specify number of servers to proceed.", "EnumServer", MB_OK | MB_TASKMODAL );
     return;
   }
   if (ValidateNumSrvrs(sznumserv,&NumSrvrs))
      return;

   srvrInfo =  (NSPRO_SERVER_INFO *)malloc(NumSrvrs*sizeof(NSPRO_SERVER_INFO));
   if(srvrInfo == NULL)
   {
       MessageBox(NULL, "Not enough memory!","EnumServer",MB_OK | MB_TASKMODAL );
       return;
    }
   countersrvrinfo = srvrInfo;
   ComboBoxServerInfo->Items->Clear(); //clear the combo box that will show the server info
   status = RNBOsproEnumServer(EnumFlag,DevID,srvrInfo,&NumSrvrs);
   if(status != 0)
   {
      NumServersEdit->Text ="";
      memset(msgSrvrInfo,0,sizeof(msgSrvrInfo));
      sprintf(msgSrvrInfo,"EnumServer failed! Return Value is %d", status);
      MessageBox(NULL,msgSrvrInfo, "EnumServer",MB_OK | MB_TASKMODAL );
   }
   else
   {
//                    MessageBox(NULL,"                   Success !\n\nClick on the combobox to view server(s) information.", "EnumServer",MB_OK | MB_TASKMODAL );
      MessageBox(NULL,"EnumServer successful! Click server info. box for details.", "EnumServer",MB_OK | MB_TASKMODAL );
      NumServersEdit->Text = NumSrvrs;
      for( i=1; i <= NumSrvrs; i++)
      {
         memset(msgSrvrInfo,0,sizeof(msgSrvrInfo));
         sprintf(msgSrvrInfo,"%s  %d",countersrvrinfo->serverAddress,countersrvrinfo->numLicAvail);
         ComboBoxServerInfo->Items->Add(msgSrvrInfo);//add server info in combobox
         if(i < NumSrvrs)
             countersrvrinfo++;
       }//end of for loop

    }// end of else(will get executed if status==0)
   free(srvrInfo);
  }

int  __fastcall TEnumServerForm::ValidateNumSrvrs(char* input,RB_WORD* NumSrvrs)
{
   char szTempStr[100], szTempInputStr[2];
   int retVal, inputStrLen,index, tempOutput;

   inputStrLen = strlen(input);

   for(index= 0; index < inputStrLen; index++)
   {
      memset(szTempInputStr,0,sizeof(szTempInputStr));
      sprintf(szTempInputStr, "%c",input[index]);
      retVal = sscanf(szTempInputStr,"%d.",&tempOutput);
      if(retVal == 0)
         break;
   }
   if((retVal == 0))
   {
    MessageBox(NULL, "Number of servers must be between 1 to 10.", "EnumServer", MB_OK | MB_TASKMODAL );
    return 1;
   }
   tempOutput = atoi(input);
   if ( (tempOutput < 1) || (tempOutput > 10) )
   {
    MessageBox(NULL, "Number of servers must be between 1 to 10.", "EnumServer", MB_OK | MB_TASKMODAL );
    return 1;
   }
   sscanf(input,"%d",NumSrvrs);
   return 0;
}
/////////////////////////////////

//---------------------------------------------------------------------------

